<app-page-title [heading]="heading" [subheading]="subheading" [icon]="icon"></app-page-title>
<!--<div class="app-page-title">
    <div class="page-title-wrapper">
        <div class="page-title-heading">
            <div class="page-title-icon">
                <i class="icon {{icon}}"></i>
            </div>
            <div>
                {{heading}}
                <div class="page-title-subheading">
                    {{subheading}}
                </div>
            </div>
        </div>
        <div class="page-title-actions">
            <button type="button"
                    class="btn-shadow d-inline-flex align-items-center btn btn-success"
                    (click)="newRecord()">
                <fa class="mr-2" name="plus"></fa>
                Nuevo
            </button>
        </div>
    </div>
</div>-->

<div class="main-card mb-3 card">
  <div class="card-body">

    <kendo-grid [data]="dataGrid" [selectable]="true" [navigable]="true" [reorderable]="true"
                [resizable]="true" [scrollable]="'virtual'" [filter]="filter" [filterable]="false"
                (filterChange)="filterChange($event)" [rowHeight]="40" [sort]="sort" [sortable]="true"
                (sortChange)="sortChange($event)" [groupable]="groupable" [group]="groups"
                (groupChange)="groupChange($event)" (dataStateChange)="dataStateChange($event)" style="height: 87vh">
      <ng-template kendoGridToolbarTemplate>
        <div class="row">
          <div class="col d-flex justify-content-end">
            <button type="button" (click)="getReporte()" class="btn btn-light"
                    [disabled]="!formSearch.valid || loading">
              <i class="fas mr-2 text-primary"
                 [ngClass]="{'fa-spinner fa-spin': loading, 'fa-search': !loading }"></i>Buscar
            </button>
            <button type="button" (click)="exportPDF()" class="btn btn-light ml-1"
                    [disabled]="!dataGrid.data">
              <i class="fas fa-file-pdf mr-2 text-danger"></i>PDF
            </button>
            <button type="button" (click)="exportExcel()" class="btn btn-light ml-1"
                    [disabled]="!dataGrid.data">
              <i class="fas fa-file-excel mr-2 text-success"></i>Excel
            </button>
            <button type="button" (click)="viewDetail()" class="btn btn-light ml-1"
                    [disabled]="!dataGrid.data">
              <i class="fas fa-external-link-alt mr-2 text-info"></i>Detalle
            </button>
            <!-- <button type="button" (click)="generateChart()" class="btn btn-light ml-1" [disabled]="!dataGrid.data" *ngIf="!flagChart" >
              <i class="fas fa-dashboard mr-2"></i>Gráfica
            </button>
            <button type="button" (click)="flagChart = false; groupable = true" class="btn btn-light ml-1" [disabled]="!dataGrid.data" *ngIf="flagChart">
                <i class="fas fa-table mr-2"></i>Grid
            </button> -->
            <button type="button" (click)="flagForm = !flagForm" class="btn btnutline-light ml-1">
              <i class="fa" [ngClass]="{ 'fa-angle-up': flagForm, 'fa-angle-down': !flagForm }"></i>
            </button>
          </div>
        </div>
        <form [formGroup]="formSearch">
          <div class="row animated fadeIn d-flex justify-content-start" *ngIf="flagForm">
            <div class="row-fluid col-7 col-sm-4 col-md-3 col-lg-3 col-xl-2">
              <div>
                <kendo-daterange>
                  <label>Fecha Desde</label>
                  <kendo-dateinput kendoDateRangeStartInput formControlName="fechaIni"
                                   [(value)]="formSearch.value.fechaIni" class="w-100">
                  </kendo-dateinput>
                  <label class="mt-1">Fecha Hasta</label>
                  <kendo-dateinput kendoDateRangeEndInput formControlName="fechaFin"
                                   [(value)]="formSearch.value.fechaFin" class="w-100">
                  </kendo-dateinput>
                </kendo-daterange>
              </div>
            </div>
            <div class="row-fluid col-5 col-sm-3 col-md-3 col-lg-3 col-xl-2">
              <div>
                <label for="tipo">Tipo Reporte</label>
                <kendo-dropdownlist
                  [data]="dsTipoReporte"
                  name="tipo"
                  class="w-100"
                  formControlName="tipo"
                  [(ngModel)]="formSearch.value.tipo"
                  [textField]="'field'"
                  [valueField]="'value'"
                  [valuePrimitive]="true">
                </kendo-dropdownlist>
              </div>
            </div>
            <div class="row-fluid col-12 col-sm-5 col-md-5 col-lg-5 col-xl-4">
              <div *ngIf="formSearch.value.tipo">
                <label for="punto">Punto</label>
                <kendo-dropdownlist
                  [data]="dsPuntos"
                  name="punto"
                  class="w-100"
                  formControlName="punto"
                  [(ngModel)]="formSearch.value.punto"
                  [textField]="'pdesc'"
                  [valueField]="'Punto'"
                  [valuePrimitive]="true">
                </kendo-dropdownlist>
              </div>
              <div class="" *ngIf="!formSearch.value.tipo">
                <label for="mesero">Mesero</label>
                <kendo-dropdownlist
                  [data]="dsMeseros"
                  name="mesero"
                  class="w-100"
                  formControlName="mesero"
                  [(ngModel)]="formSearch.value.mesero"
                  [textField]="'mnombre'"
                  [valueField]="'Mesero'"
                  [valuePrimitive]="true">
                </kendo-dropdownlist>
              </div>
              <div class="">
                <label for="clase">Clase</label>
                <kendo-dropdownlist
                  [data]="dsClases"
                  name="clase"
                  class="w-100"
                  formControlName="clase"
                  [(ngModel)]="formSearch.value.clase"
                  [textField]="'cdesc'"
                  [valueField]="'clase'"
                  [valuePrimitive]="true">
                </kendo-dropdownlist>
              </div>
            </div>
            <div class="row-fluid my-3">
              <div class="col-auto my-1">
                <div class="custom-control custom-checkbox mr-sm-2">
                  <input type="checkbox" class="custom-control-input" id="cbDescuentos"
                         formControlName="descuentos"
                         [(ngModel)]="formSearch.value.descuentos">
                  <label class="custom-control-label" for="cbDescuentos">Descuentos</label>
                </div>
              </div>
              <div class="col-auto my-1">
                <div class="custom-control custom-checkbox mr-sm-2">
                  <input type="checkbox" class="custom-control-input" id="cbDetalle"
                         formControlName="detalle"
                         [(ngModel)]="formSearch.value.detalle">
                  <label class="custom-control-label" for="cbDetalle">Detalle</label>
                </div>
              </div>
              <div class="col-auto my-1" *ngIf="formSearch.value.detalle">
                <div class="custom-control custom-checkbox mr-sm-2">
                  <input type="checkbox" class="custom-control-input" id="cbIncBorrados"
                         formControlName="borrados"
                         [(ngModel)]="formSearch.value.borrados">
                  <label class="custom-control-label" for="cbIncBorrados">Inc. Borrados</label>
                </div>
              </div>
            </div>
          </div>
        </form>
        <div class="animated fadeIn d-flex justify-content-center w-100" *ngIf="flagChart">
          <app-chart-comandas [dataGrid]="dataGrid"></app-chart-comandas>
        </div>
      </ng-template>
      <ng-container *ngIf="!flagChart">
        <kendo-grid-column field="ttipo" title="Tipo" [filterable]="true" width="90"
                           class="text-right"></kendo-grid-column>
        <kendo-grid-column field="tplat" title="Platillo" [filterable]="false" width="90"
                           class="text-right"></kendo-grid-column>
        <kendo-grid-column field="tcom" title="#Com" [filterable]="true" width="100"
                           class="text-right"></kendo-grid-column>
        <kendo-grid-column field="tporc1" title="Alim. Porc." [filterable]="true" width="110"
                           class="text-right"></kendo-grid-column>
        <kendo-grid-column field="tmont1" title="Importe" [filterable]="true" width="110" class="text-right">
          <ng-template kendoGridCellTemplate
                       let-dataItem>{{ dataItem.tmont1 | kendoNumber:'##.00' }}</ng-template>
        </kendo-grid-column>
        <kendo-grid-column field="tporc2" title="Beb. Porc." [filterable]="false" width="110"
                           class="text-right"></kendo-grid-column>
        <kendo-grid-column field="tmont2" title="Importe" [filterable]="false" width="110" class="text-right">
          <ng-template kendoGridCellTemplate
                       let-dataItem>{{ dataItem.tmont2 | kendoNumber:'##.00' }}</ng-template>
        </kendo-grid-column>
        <kendo-grid-column field="tporc3" title="Var. Porc." [filterable]="false" width="110"
                           class="text-right"></kendo-grid-column>
        <kendo-grid-column field="tmont3" title="Importe" [filterable]="true" width="110" class="text-right">
          <ng-template kendoGridCellTemplate
                       let-dataItem>{{ dataItem.tmont3 | kendoNumber:'##.00' }}</ng-template>
        </kendo-grid-column>
        <kendo-grid-column field="tclas" title="Clase" [filterable]="false" width="90"></kendo-grid-column>
        <kendo-grid-column field="tpunt" title="P.V." [filterable]="true" width="80"
                           class="text-right"></kendo-grid-column>
        <kendo-grid-column field="tcheq" title="#Cheque" [filterable]="false" width="110"
                           class="text-right"></kendo-grid-column>
        <kendo-grid-column field="tmes" title="Mesero" [filterable]="false" width="100"></kendo-grid-column>
        <kendo-grid-column field="tfec" title="Fec. Comanda" [filterable]="false"
                           width="135"></kendo-grid-column>
        <kendo-grid-column field="tcod" title="Mov" [filterable]="true" width="90"></kendo-grid-column>
      </ng-container>
    </kendo-grid>

    <kendo-window title="Total por Comanda" [(left)]="windowLeft" class="w-100 animated fadeIn"
                  *ngIf="flagViewDetail"
                  (close)="close()">
      <kendo-grid
        [data]="dsResumen"
        [selectable]="true"
        [navigable]="true"
        [reorderable]="true"
        [resizable]="true"
        [rowHeight]="40"
        [sort]="sort2"
        [sortable]="true"
        (sortChange)="sortChange2($event)"
        style="height: 87vh">
        <kendo-grid-column field="tpunt" title="P.V." width="90" class="text-right"></kendo-grid-column>
        <kendo-grid-column field="tcheq" title="#Cheque" width="120" class="text-right"></kendo-grid-column>
        <kendo-grid-column field="tcom" title="# Com" width="110" class="text-right"></kendo-grid-column>
        <kendo-grid-column field="tporc1" title="Alim. Porc." width="120"
                           class="text-right"></kendo-grid-column>
        <kendo-grid-column field="tmont1" title="Importe" width="110" class="text-right">
          <ng-template kendoGridCellTemplate
                       let-dataItem>{{ dataItem.tmont1 | kendoNumber:'##.00' }}</ng-template>
        </kendo-grid-column>
        <kendo-grid-column field="tporc2" title="Bebidas Porc." width="110"
                           class="text-right"></kendo-grid-column>
        <kendo-grid-column field="tmont2" title="Importe" width="120" class="text-right">
          <ng-template kendoGridCellTemplate
                       let-dataItem>{{ dataItem.tmont2 | kendoNumber:'##.00' }}</ng-template>
        </kendo-grid-column>
        <kendo-grid-column field="tporc3" title="Varios Porc." width="120"
                           class="text-right"></kendo-grid-column>
        <kendo-grid-column field="tmont3" title="Importe" width="110" class="text-right">
          <ng-template kendoGridCellTemplate
                       let-dataItem>{{ dataItem.tmont3 | kendoNumber:'##.00' }}</ng-template>
        </kendo-grid-column>
        <kendo-grid-column field="tfec" title="Fec. Comanda" width="140"></kendo-grid-column>
        <kendo-grid-column field="thora" title="Hora" width="110">
          <ng-container *ngIf="dataGrid.data">
            <ng-template kendoGridCellTemplate let-dataItem let-rowIndex="rowIndex">
              {{ dataItem.thora | hour }}
            </ng-template>
          </ng-container>
        </kendo-grid-column>
      </kendo-grid>
      <div class="row d-flex justify-content-center mt-4">
        <button type="button" class="btn btn-primary px-4 py-3" (click)="close()">Cerrar</button>
      </div>
    </kendo-window>

    <div id="tblExcel" style="display: none;">
      <table id="tbl1" border="2">
        <thead>
        <tr>
          <th>Fecha</th>
          <th>Hora</th>
          <th>#Com</th>
          <th>Porcion A</th>
          <th>Importe A</th>
          <th>Porcion B</th>
          <th>Importe B</th>
          <th>Porcion V</th>
          <th>Importe V</th>
          <th>Mesero</th>
          <th>Cheque</th>
          <th>EA</th>
          <th>I</th>
        </tr>
        </thead>
        <tbody>
        <tr *ngFor="let item of dsResumen.data">
          <td>{{ item.tfec }}</td>
          <td>{{ item.thora }}</td>
          <td>{{ item.tcom }}</td>
          <td>{{ item.tporc1 }}</td>
          <td>{{ item.tmont1 | number:'1.2-2' }}</td>
          <td>{{ item.tporc2 }}</td>
          <td>{{ item.tmont2 | number:'1.2-2' }}</td>
          <td>{{ item.tporc3 }}</td>
          <td>{{ item.tmont3 | number:'1.2-2' }}</td>
          <td>{{ item.tmes  }}</td>
          <td>{{ item.tcheq }}</td>
          <td>{{ item.teac  }}</td>
          <td>{{ item.tclas }}</td>
        </tr>
        <tr>
          <td></td>
        </tr>
        </tbody>
      </table>
      <table border="2" id="tbl2">
        <thead>
        <tr>
          <th>Clase</th>
          <th>P. Vta.</th>
          <th>Descripción</th>
          <th>Porcion A</th>
          <th>Importe A</th>
          <th>Porcion B</th>
          <th>Importe B</th>
          <th>Porcion V</th>
          <th>Importe V</th>
        </tr>
        </thead>
        <tbody>
        <tr *ngFor="let item of dsTotalPv">
          <td>{{ item.tclas }}</td>
          <td>{{ item.tpunt }}</td>
          <td>{{ item.tdesc }}</td>
          <td>{{ item.tporc1 }}</td>
          <td>{{ item.tmont1 | number:'1.2-2' }}</td>
          <td>{{ item.tporc2 }}</td>
          <td>{{ item.tmont2 | number:'1.2-2' }}</td>
          <td>{{ item.tporc3 }}</td>
          <td>{{ item.tmont3 | number:'1.2-2' }}</td>
          <td>{{ item.timp | number:'1.2-2' }}</td>
        </tr>
        </tbody>
      </table>
    </div>

  </div>
</div>
